//This is a medium-sized New Keynesian model. It computes impules responses with first and second order perturbations and graphs the impulses responses for gdp.
//The second order perturbation is done with pruning. If you don't prune, then problems occur.

var 
c
consumption_obs, 
epsil, 
Fp,
Fw, 
g,
gdp_obs,
h,
hours_obs, 
i,
inflation_obs, 
investment_obs,
kbar,
lambdaf, 
lambdaz,
muup,
muzstar, 
phi,
pi,
pinvest_obs,
pitarget,
pstar,
q,
Re, 
Re_obs,
RealRe_obs,
rk,
Rk,
s,
u,
wage_obs,
wtilde,
wstar, 
zetac,
zetai;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Declare the exogenous variables in the model.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% All have been checked.  All are used.
varexo 
e_epsil,
e_g,
e_lambdaf, 
e_muup,
e_muzstar, 
e_pitarget,
e_xp,
e_zetac,
e_zetai;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Declare the parameters in the model.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameters
actil_p,
adptil_p,
adytil_p,
alpha_p,
aptil_p,
aytil_p,
b_p,
beta_p,
c_p,
delta_p,
epsil_p,
etag_p,
g_p,
i_p,
iota1_p,
iotamu_p,
iotaw1_p,
lambdaf_p,
lambdaw_p,
mu_p,
muup_p,
muzstar_p,
pi_p,
pibar_p,
pitarget_p,
psik_p,
psil_p,
psiL_p,
Re_p,
rhoepsil_p,
rhog_p,
rholambdaf_p,
rhomuup_p,
rhomuzstar_p,
rhopitarget_p,
rhoterm_p,
rhozetac_p,
rhozetai_p,
rhotil_p,
rk_p,
Sdoupr_p,
sigmaL_p,
sigmaa_p,
stdepsil_p,
stdg_p,
stdlambdaf_p,
stdmuup_p,
stdmuzstar_p,
stdpitarget_p,
stdterm_p,
stdxp_p,
stdzetac_p,
stdzetai_p,
tauc_p,
taud_p,
tauk_p,
taul_p,
tauo_p,
term_p,
upsil_p,
we_p,
xip_p,
xiw_p,
zeta_p,
zetac_p,
zetai_p;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calibrate the parameters.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
stdlambdaf_p   = 0.0109559606811660 ;  
stdmuup_p      = 0.0039857917638490 ;	 
stdg_p         = 0.0228127233194570 ;	 
stdmuzstar_p   = 0.0071487847687080 ;	 
stdgamma_p     = 0.0081035403472920 ;	 
stdepsil_p     = 0.0046338119312200 ;	 
stdxp_p        = 0.4893446208831330 ;	 
stdzetac_p     = 0.0233253551183060 ;	 
stdzetai_p     = 0.0549648244379450 ;	 
stdterm_p      = 0.0016037530257270 ;	 

xiw_p          = 0.8127963113950160 ;	 
b_p            = 0.7358438226929010 ;	 
Fomegabar_p    = 0.0055885692972290 ;	 
mu_p           = 0.2148945111281970 ;	 
sigmaa_p       = 2.5355534195260200 ;	 
Sdoupr_p       = 10.780000003442200 ;	 
xip_p          = 0.7412186033856290 ;	 
aptil_p        = 2.3964959426752000 ;	 
rhotil_p       = 0.8502964502607260 ;	 
iota1_p        = 0.8973670521349900 ;	 
iotaw1_p       = 0.4890735358842230 ;	 
iotamu_p       = 0.9365652807278990 ;	 
adytil_p       = 0.3649436543356210 ;
rholambdaf_p   = 0.9108528528580380 ;	 
rhomuup_p      = 0.9870257396836700 ;	 
rhog_p         = 0.9427215849959780 ;	 
rhomuzstar_p   = 0.1459051086113400 ;	 
rhoepsil_p     = 0.8089285617540170 ;	 
rhosigma_p     = 0.9706370265612010 ;	 
rhozetac_p     = 0.8968400853887450 ;	 
rhozetai_p     = 0.9086616567125290 ;	 
rhoterm_p      = 0.9743991813961140 ;	  
stdsigma2_p    = 0.0282985295279650 ;
stdsigma1_p    = 0.0700061676650730 ;	 
	
actil_p           = 0;
adptil_p          = 0;
alpha_p           = 0.4;
aytil_p           = 0;
b_p               = 0.799976116140621;
beta_p            = 0.998704208591811;
bigtheta_p        = 0.005;
c_p               = 1.545858551297361;
delta_p           = 0.025;
epsil_p           = 1;
etag_p            = 0.2043;
g_p               = 0.586751768198739;
gamma_p           = 0.985;
i_p               = 0.739400293322006;
lambdaf_p         = 1.2;
lambdaw_p         = 1.05;
muup_p            = 1;
muzstar_p         = 1.004124413586981;
pi_p              = 1.006010795406775;
pibar_p           = 1.006010795406775;
pitarget_p        = 1.006010795406775;
psik_p            = 0;
psil_p            = 0;
psiL_p            = 0.7705;
Re_p              = 0.011470654984364;
rhogamma_p        = 0;
rhopitarget_p     = 0.975;
rk_p              = 0.052074658244454;
sigmaL_p          = 1;
sigma_p           = 0.327545843119697;
stdpitarget_p     = 0.0001;
tauc_p            = 0.047;
taud_p            = 0;
tauk_p            = 0.32;
taul_p            = 0.241;
tauo_p            = 1;
term_p            = 1;
upsil_p           = 1.004223171829000;
we_p              = 0.005;
zeta_p            = 1;
zetac_p           = 1;
zetai_p           = 1;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Auxiliary expressions.  These simplify the equations without adding
% additional variables.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  # pitilde    = (pitarget^iota1_p * pi(-1)^(1-iota1_p) * pibar_p^(1-iota1_p-(1-iota1_p)));
  # Kp         = (Fp * ((1 - xip_p * (pitilde / pi)^(1/(1-lambdaf))) / (1 - xip_p))^(1-lambdaf));
  # a          = (rk_p * (exp(sigmaa_p * (u - 1)) - 1) / sigmaa_p);
  # pitildep1  = (pitarget(+1)^iota1_p * pi^(1-iota1_p) * pibar_p^(1-iota1_p-(1-iota1_p)));
  # yz         = (pstar^(lambdaf/(lambdaf-1)) * (epsil * (u * kbar(-1) / (muzstar * upsil_p))^alpha_p 
                 * (h * wstar^(lambdaw_p/(lambdaw_p-1)))^(1-alpha_p) - phi));
  # Kpp1       = (Fp(+1) * ((1 - xip_p * (pitildep1 / pi(+1))^(1/(1-lambdaf(+1)))) / (1 - xip_p))^(1-lambdaf(+1)));
  # pitildewp1 = (pitarget(+1)^iotaw1_p * pi^(1-iotaw1_p) * pibar_p^(1-iotaw1_p-(1-iotaw1_p)));
  # piwp1      = (pi(+1) * muzstar(+1) * wtilde(+1) / wtilde);
  # piw        = (pi * muzstar * wtilde / wtilde(-1));
  # pitildew   = (pitarget^iotaw1_p * pi(-1)^(1-iotaw1_p) * pibar_p^(1-iotaw1_p-(1-iotaw1_p)));
  # Kwp1       = (((1 - xiw_p * (pitildewp1 / piwp1 * muzstar_p^(1-iotamu_p) * muzstar(+1)^iotamu_p)^(1/(1-lambdaw_p))) 
                 / (1-xiw_p))^(1-lambdaw_p*(1+sigmaL_p)) * wtilde(+1) * Fw(+1) / psiL_p);
  # Kw         = (((1 - xiw_p * (pitildew / piw * muzstar_p^(1-iotamu_p) * muzstar^iotamu_p)^(1/(1-lambdaw_p))) 
                 / (1 - xiw_p))^(1-lambdaw_p*(1+sigmaL_p)) * wtilde * Fw / psiL_p);
  # rk_ss      = steady_state(rk);
  # S          = (exp(sqrt(Sdoupr_p / 2)*(zetai * muzstar * upsil_p * i / i(-1) - muzstar_p * upsil_p))
                 + exp(-sqrt(Sdoupr_p / 2) * (zetai * muzstar * upsil_p * i/i(-1) - muzstar_p * upsil_p)) - 2);
  # Spr        = (sqrt(Sdoupr_p / 2) * (exp(sqrt(Sdoupr_p / 2) * (zetai * muzstar * upsil_p * i / i(-1) - muzstar_p * upsil_p)) 
                 - exp(-sqrt(Sdoupr_p / 2) * (zetai * muzstar * upsil_p * i / i(-1) - muzstar_p * upsil_p))));
  # Sprp1      = (sqrt(Sdoupr_p / 2) * (exp(sqrt(Sdoupr_p / 2) * (zetai(+1) * muzstar(+1) * upsil_p * i(+1) / i - muzstar_p * upsil_p)) 
                 - exp(-sqrt(Sdoupr_p / 2) * (zetai(+1) * muzstar(+1) * upsil_p * i(+1) / i - muzstar_p * upsil_p))));

  # Rk_ss      = (steady_state(Rk));
  # kbar_ss    = (steady_state(kbar));
  # h_ss       = (steady_state(h));
  # g_ss       = (steady_state(g));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Equations characterizing equilibrium.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Eqn 1: Law of motion for \latex{p^*}
    pstar = ((1 - xip_p) * (Kp / Fp)^(lambdaf/(1-lambdaf)) 
            + xip_p * ((pitilde / pi) * pstar(-1))^(lambdaf/(1-lambdaf)))^((1-lambdaf)/lambdaf);
  
  % Eqn 2: Law of motion for \latex{F_p}.
    Fp = zetac * lambdaz * yz + (pitildep1 / pi(+1))^(1/(1-lambdaf(+1))) * beta_p * xip_p * Fp(+1);
  
  % Eqn 3: Law of motion for \latex{K_p}
    Kp = zetac * lambdaf * lambdaz * pstar^(lambdaf/(lambdaf-1)) * yz * s 
         + beta_p * xip_p * (pitildep1 / pi(+1))^(lambdaf(+1)/(1-lambdaf(+1))) * Kpp1;
  
  % Eqn 4: Relationship between \latex{K_p} and \latex{F_p}.
  % This equation is contained in the definitions of Kp and Kpp1 in the
  % auxiliary equations.
  
  % Eqn 5: Law of motion for \latex{F_w}.
    Fw = zetac * lambdaz * wstar^(lambdaw_p/(lambdaw_p-1)) * h * (1 - taul_p) / lambdaw_p 
         + beta_p * xiw_p * muzstar_p^((1-iotamu_p)/(1-lambdaw_p)) * (muzstar(+1)^(iotamu_p/(1-lambdaw_p)-1))
         * pitildewp1^(1/(1-lambdaw_p)) / pi(+1) * (1 / piwp1)^(lambdaw_p/(1-lambdaw_p))  *  Fw(+1);
  
  % Eqn 6: Law of motion for \latex{K_w}.
    Kw = zetac * (wstar^(lambdaw_p/(lambdaw_p-1)) * h)^(1+sigmaL_p) * zeta_p + beta_p * xiw_p
         * (pitildewp1 / piwp1 * muzstar_p^(1-iotamu_p) * muzstar(+1)^iotamu_p)^(lambdaw_p*(1+sigmaL_p)/(1-lambdaw_p)) * Kwp1;
  
  % Eqn 7: Relationship between \latex{F_w} and \latex{K_w}.
  % This equation is contained in the definitions of Kw and Kwp1 in the
  % auxiliary equations.
  
  % Eqn 8: Law of motion of \latex{w^*}
    wstar = ((1 - xiw_p) * ( ((1 - xiw_p * (pitildew / piw * muzstar_p^(1-iotamu_p) * (muzstar^iotamu_p))^(1/(1-lambdaw_p))) 
            / (1 - xiw_p))^lambdaw_p ) + xiw_p * (pitildew / piw * muzstar_p^(1-iotamu_p) * muzstar^iotamu_p 
            * wstar(-1))^(lambdaw_p/(1-lambdaw_p)))^(1/(lambdaw_p/(1-lambdaw_p)));
  
  % Eqn 9: Efficiency condition for setting captial utilization
    rk = tauo_p * rk_ss * exp(sigmaa_p * (u - 1));
  
  % Eqn 10: Rental rate on capital 
    rk = alpha_p * epsil * ((upsil_p * muzstar * h * wstar^(lambdaw_p/(lambdaw_p-1)) /(u * kbar(-1)))^(1 - alpha_p)) * s;
  
  % Eqn 11: Marginal Cost 
    s = (rk / alpha_p)^alpha_p * (wtilde / (1 - alpha_p))^(1-alpha_p) / epsil;
  

  % Eqn 12: Resource constraint
    yz = g + c + i / muup + tauo_p * a * kbar(-1) / (muzstar * upsil_p) ; 

  % Eqn 13: Law of motion for capital
    kbar = (1 - delta_p) * kbar(-1) / (muzstar * upsil_p) + (1 - S) * i;
  
  % Eqn 14: Household FOC w.r.t. risk-free bonds
    0 = beta_p * zetac(+1) * lambdaz(+1) / (muzstar(+1) * pi(+1)) * (1 + (1 - taud_p) * Re) - zetac * lambdaz;
  
  % Eqn 15: Household FOC w.r.t. consumption
    (1 + tauc_p) * zetac * lambdaz = muzstar * zetac / (c * muzstar - b_p * c(-1)) 
                                     - b_p * beta_p * zetac(+1) / (c(+1) * muzstar(+1) - b_p * c);
  
  % Eqn 16: FOC for capital
    0 = beta_p * zetac(+1) * lambdaz(+1) / (muzstar(+1) * pi(+1)) * (1 + Rk(+1)) - zetac * lambdaz;
  
  % Eqn 17: Definition of return of entrepreneurs, Rk
    1 + Rk = ((1 - tauk_p) * (u * rk - tauo_p * a) + (1 - delta_p) * q) * pi / (upsil_p * q(-1)) + tauk_p * delta_p;
  
  % Eqn 18: Household FOC w.r.t. investment
    0 = - zetac * lambdaz / muup + lambdaz * zetac * q * (-Spr * zetai * i * muzstar * upsil_p / i(-1) + 1 - S)
        + beta_p * zetac(+1) * lambdaz(+1) * q(+1) * Sprp1 * (zetai(+1) * i(+1) * muzstar(+1) * upsil_p / i)^2 / (muzstar(+1) * upsil_p);
  
  % Eqn 19: Definition of yz.  
  % This equation is represented in the definition of yz in the definition
  % of the auxiliary equations.
  
  % Eqn 20: Monetary Policy Rule
  %  log(Re / Re_p) = rhotil_p * log(Re(-1) / Re_p) + (1 / Re_p) * (1 - rhotil_p) 
  %                   * (aptil_p * pi_p * log(pi(+1) / pitarget) + (1 / 4) * adytil_p * muzstar_p * log(gdp_obs));
  % monetary policy rule with short term interest rate:
    log(Re / Re_p) = rhotil_p * log(Re(-1) / Re_p) + (1 / Re_p) * (1 - rhotil_p) * pi_p * log(pitarget / pi_p) 
                     + (1 / Re_p) * (1 - rhotil_p) * aptil_p * pi_p * (log(pi(+1)) - log(pitarget)) 
                     + (1 / (4 * Re_p)) * (1 - rhotil_p) * adytil_p * muzstar_p * ((c_p * log(c / c(-1)) 
                     + i_p * log(i / i(-1)) - i_p * log(muup / muup(-1)) + g_p * log(g / g(-1)) ) / ( (c_p+i_p)/(1-etag_p) ) 
                     + log(muzstar / muzstar_p)) + (1 / Re_p) * (1 - rhotil_p) * adptil_p * log(pi / pi(-1)) 
                     - (1 / (4 * Re_p)) * (1 - rhotil_p) * aytil_p * (c_p * log(c / c_p) + i_p * log(i / i_p) 
                     - i_p * log(muup) + g_p * log(g / g_p)) / ((c_p+i_p)/(1-etag_p))
                     + (1 / (400 * Re_p)) * e_xp;
  % Eqn 21: GDP
  % This is not used.  It is only used in the manuscript in the monetary
  % policy rule.
  %  # y = g + c + i / muup;
  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Observation equations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  consumption_obs = c / c(-1) * muzstar / muzstar_p;
  gdp_obs         = (c + i / muup + g) / (c(-1) + i(-1) / muup(-1) + g(-1)) * muzstar / muzstar_p;
  hours_obs       = h / h_ss;
  inflation_obs   =  pi / pi_p;
  investment_obs  = i / i(-1) * muzstar / muzstar_p;
  pinvest_obs     = muup(-1) / muup;
  Re_obs          = exp(Re - Re_p);
  RealRe_obs      = ((1 + Re) / pi(+1))/((1 + Re_p) / pi_p);
  wage_obs        = wtilde / wtilde(-1) * muzstar / muzstar_p;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Shock equations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  log(epsil / epsil_p)       = rhoepsil_p    * log(epsil(-1) / epsil_p)       +  e_epsil;
  log(g / g_ss)              = rhog_p        * log(g(-1) / g_ss)              +  e_g;
  log(lambdaf / lambdaf_p)   = rholambdaf_p  * log(lambdaf(-1) / lambdaf_p)   +  e_lambdaf;
  log(muup / muup_p)         = rhomuup_p     * log(muup(-1) / muup_p)         +  e_muup;
  log(muzstar / muzstar_p)   = rhomuzstar_p  * log(muzstar(-1) / muzstar_p)   +  e_muzstar;
  log(pitarget / pitarget_p) = rhopitarget_p * log(pitarget(-1) / pitarget_p) +  e_pitarget;
  log(zetac / zetac_p)       = rhozetac_p    * log(zetac(-1) / zetac_p)       +  e_zetac;
  log(zetai / zetai_p)       = rhozetai_p    * log(zetai(-1) / zetai_p)       +  e_zetai;
  
  phi = steady_state(phi);

end;

% Compute the steady state of the model.
steady;

% Compute the eigenvalues of the model linearized around the steady state.
check;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The 'shocks' block specifies the non zero elements of the covariance 
% matrix of the shocks of exogenous variables.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
shocks; 
var e_xp;       stderr stdxp_p;
var e_lambdaf;  stderr stdlambdaf_p;
var e_pitarget; stderr stdpitarget_p;
var e_muup;     stderr stdmuup_p;
var e_g;        stderr stdg_p;
var e_muzstar;  stderr stdmuzstar_p;
var e_epsil;    stderr stdepsil_p;
var e_zetac;    stderr stdzetac_p;
var e_zetai;    stderr stdzetai_p;
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Stochastic Simulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
stoch_simul(order = 2, irf = 50, periods = 1000, nograph, drop=50, replic=500, pruning)
            gdp_obs consumption_obs investment_obs inflation_obs;
outp2=gdp_obs_e_epsil;
infl2=inflation_obs_e_epsil;
cons2=consumption_obs_e_epsil;
inv2=investment_obs_e_epsil;

stoch_simul(order = 1, irf = 50, periods = 1000, nograph)
            gdp_obs consumption_obs investment_obs inflation_obs;

outp=gdp_obs_e_epsil;
infl=inflation_obs_e_epsil;
cons=consumption_obs_e_epsil;
inv=investment_obs_e_epsil;

tt=1:length(outp2);
subplot(2,2,1)
plot(tt,outp,tt,outp2,'*-')
axis tight
legend('linear','second order')
title('GDP')
subplot(2,2,2)
plot(tt,infl,tt,infl2,'*-')
axis tight
title('inflation')
subplot(2,2,3)
plot(tt,cons,tt,cons2,'*-')
axis tight
title('consumption')
subplot(2,2,4)
plot(tt,inv,tt,inv2,'*-')
axis tight
title('investment')

